      Subroutine out_micro ( Tb_out, ngridx, ngridy, nlyr, 
     &                       deltax, deltay, freq, inc_angle_mwr, 
     &                       filename )
      Implicit NONE
c
c This subroutine writes out microwave brightness temperature
c
c Inputs:
c  - Sensor parameters
c     freq, inc_angle_mwr
c  - Model spatial dimensions
c     ngridx, ngridy, nlyr, deltax, deltay
c  - I/O
c     filename
c  - Simulated result
c     Tb_out
c
c Output:
c  - (NONE)
c
      Include '../MAINparameters.inc'
c
      Integer i,j,l,m,nchar,length_char
      character*90 pathandfile
      character*(*) filename
c
      nchar = length_char ( filename )
      nchar = nchar - 8    !! to eliminate '.profile' at the end.
c
c Data dimensions in ascii format
c
      pathandfile = outputdir//filename(1:nchar)//'.mwr.info'
      open(unit= 15, file = pathandfile,
     +     status = 'unknown', form = 'formatted')
c
      write(15,551) ngridx, ngridy, nlyr, deltax, deltay
      write(15,*) 'viewing angle:',inc_angle_mwr
      write(15,*)   mxfreq,'frequencies at ',freq,' GHz.'
      write(15,*) 'The output contains a pair of Tbs at each frequency'
     &          //' for H and V, in this order, polarizations.'
c
c Computed Tbs in binary format
c
      pathandfile = outputdir//filename(1:nchar)//'.mwr.bin'
      open(unit= 20, file = pathandfile, access = 'direct', 
     +     recl = ngridx*ngridy*mxfreq*2*4)
c
      write(20,rec=1) ((((Tb_out(i,j,l,m),i=1,ngridx),j=1,ngridy),
     &                    m=0,1),l=1,mxfreq)
c
  551 format(i3,' x ',i3,' (x,y) grid; ',i3,' layers; ',
     &       ' deltax = ',f6.2,' km','  deltay = ',f6.2,' km')
  552 format(i2,1x,6f8.3,1x,i3,4f7.3)
c
      Close (15)
      Close (20)
c
      Return
      End
