      SUBROUTINE AINTEG(M,L,NDA,NA0,I,FSOL,AM1U,AM0,W,T,T1,T2
     &     ,ZEE,QE,QIE,VPE,VME,PT10,PR10,PT1,PR1,ALFA,BETA
     &     ,NPLK1,DPE,DME,CPLK,AI)
C--- INPUT
C M       I         FOURIER ORDER
C L       I         LAYER NUMBER
C NDA
C NA0
C FSOL
C I       I         STREAM NUMBER FOR AM1(I)
C AM1U    R         USER DEFINED DIRECTION
C AM0   R(KNA0)
C W       R         SINGLE SCATTERING ALBEDO
C T       R         OPTICAL DEPTH FOR INTERPOLATION
C T1      R         OPTICAL DEPTH AT THE TOP OF THE SUBLAYER
C T2      R         OPTICAL DEPTH AT THE BOTTOM OF THE SUBLAYER.
C
      include 'VISIRparameters.inc'
c
c      PARAMETER (KNDM  =10)
c      PARAMETER (KNA1U =10)
c      PARAMETER (KNA1  =10)
c      PARAMETER (KNA0  =10)
c      PARAMETER (KNLN  =50)
c      PARAMETER (KPLK1 =2)
C
      PARAMETER (PI=3.141592654)
      DIMENSION AM0(KNA0),ZEE(KNDM,KNLN),QE(KNDM,KNDM,KNLN)
     & ,QIE(KNDM,KNDM,KNLN),VPE(KNDM,KNA0,KNLN),VME(KNDM,KNA0,KNLN)
     & ,PT10(KNA1,KNA0),PR10(KNA1,KNA0),PT1(KNA1,KNDM),PR1(KNA1,KNDM)
     & ,DPE(KNDM,KPLK1,KNLN),DME(KNDM,KPLK1,KNLN),AI(KNA0)
     & ,ALFA(KNDM,KNA0),BETA(KNDM,KNA0),CPLK(KPLK1,KNLN)
C WORKING AREAS
      DIMENSION H1(KNDM),H2(KNDM),C(KNDM),SL(KNDM),SL1(KNDM),EI(KNA0)
     & ,PKI(KPLK1)
      TT1=0
      TT2=T2-T1
      TT =T -T1
      AM1=ABS(AM1U)
      DO 1 J=1,NDA
        SUM1=0
        SUM2=0
        DO 2 K=1,NDA
        SUM1=SUM1+(PT1(I,K)+PR1(I,K))*QE (K,J,L)
    2   SUM2=SUM2+(PT1(I,K)-PR1(I,K))*QIE(J,K,L)
        H1(J)=W*SUM1
    1 H2(J)=W*SUM2
C DOWNWARD INTENSITY
      IF(AM1U.GT.0.0) THEN
        DO 3 J=1,NA0
    3   CALL EXINT(AM1U,AM0(J),TT,TT1,TT,EI(J))
        DO 4 J=1,NDA
    4   CALL CSINT(AM1U,ZEE(J,L),TT2,TT,TT1,TT,C(J),SL(J),SL1(J))
        PDU=0
        IF(M.EQ.0 .AND. NPLK1.GT.0) THEN
          CALL PKINT(AM1U,TT,TT1,TT,NPLK1,PKI)
          DO 6 J=1,NPLK1
          SUM1=0
          DO 5 K=1,NDA
    5     SUM1=SUM1+PT1(I,K)*DPE(K,J,L)+PR1(I,K)*DME(K,J,L)
    6     PDU=PDU+(W*SUM1+2*PI*(1-W)*CPLK(J,L))*PKI(J)
        ENDIF
        DO 7 J=1,NA0
        TRNS0=-T1/AM0(J)
        TRNS0=EXPFN(TRNS0)*FSOL
        PVU=PT10(I,J)*TRNS0
        HU=0
        DO 8 K=1,NDA
        HU=HU+(H1(K)*C  (K)-H2(K)*SL(K))*ALFA(K,J)
     &       +(H1(K)*SL1(K)-H2(K)*C (K))*BETA(K,J)
    8   PVU=PVU+PT1(I,K)*VPE(K,J,L)+PR1(I,K)*VME(K,J,L)
        PVU=W*PVU*EI (J)
        AI(J)=(HU+PVU+PDU)/AM1
    7   CONTINUE
       ELSE
C UPWARD INTENSITY
        DO 13 J=1,NA0
   13   CALL EXINT(AM1U,AM0(J),TT,TT,TT2,EI(J))
        DO 14 J=1,NDA
   14   CALL CSINT(AM1U,ZEE(J,L),TT2,TT,TT,TT2,C(J),SL(J),SL1(J))
        PDU=0
        IF(M.EQ.0 .AND. NPLK1.GT.0) THEN
          CALL PKINT(AM1U,TT,TT,TT2,NPLK1,PKI)
          DO 16 J=1,NPLK1
          SUM1=0
          DO 15 K=1,NDA
   15     SUM1=SUM1+PR1(I,K)*DPE(K,J,L)+PT1(I,K)*DME(K,J,L)
   16     PDU=PDU+(W*SUM1+2*PI*(1-W)*CPLK(J,L))*PKI(J)
        ENDIF
        DO 17 J=1,NA0
        TRNS0=-T1/AM0(J)
        TRNS0=EXPFN(TRNS0)*FSOL
        PVU=PR10(I,J)*TRNS0
        HU=0
        DO 18 K=1,NDA
        HU=HU+(H1(K)*C  (K)+H2(K)*SL(K))*ALFA(K,J)
     &       +(H1(K)*SL1(K)+H2(K)*C (K))*BETA(K,J)
   18   PVU=PVU+PR1(I,K)*VPE(K,J,L)+PT1(I,K)*VME(K,J,L)
        PVU=W*PVU*EI (J)
        AI(J)=(HU+PVU+PDU)/AM1
   17   CONTINUE
      ENDIF
      RETURN
      END
