      SUBROUTINE CONVU(N,AM,JJ,ER,IC,EPSU,NCHK)
C CHECK CONVERGENCE OF INTENSITY IN THE DIRECTION OF MU
C--- HISTORY
C 90. 1.20 CREATED
C--- INPUT
C N      I        NUMBER OF STREAMS TO BE CHECKED
C AM    R(N)      DIRECTION OF STREAM
C JJ    I(N)      STREAM NUMBER IN THE ORIGINAL ORDER
C ER    R(N)      MAXIMUM ERROR FOR THE STREAM REGARDLESS OF OTHER
C                  ANGLES AND LAYERS
C IC    I(N)      NUMBER OF CONSECTIVE SERIES WITH -ER- LESS THAN -EPSU-
C EPSU    R       CONVERGENCE CRITERION
C NCHK    I       MAX. NUMBER FOR THE VALUE OF -IC- BY WHICH THE
C                  ROUTINE CONFIRMS CONVERGENCE
C--- OUTPUT
C N, AM, JJ, IC   UPDATED AFTER DROPPING CONVERGENT STREAMS
C$ENDI
      DIMENSION AM(*),JJ(*),ER(*),IC(*)
      J1=0
      DO 1 J=1,N
      IF(ABS(ABS(AM(J))-1).LE.0) THEN
        IC(J)=999
        ER(J)=0
      ENDIF
      IF(ER(J).LT.EPSU) THEN
        IC(J)=IC(J)+1
        IF(IC(J).GE.NCHK) GOTO 1
       ELSE
        IC(J)=0
      ENDIF
      J1=J1+1
      IC(J1)=IC(J)
      JJ(J1)=JJ(J)
      AM(J1)=AM(J)
      ER(J1)=ER(J)
    1 CONTINUE
      N=J1
      RETURN
      END
