      SUBROUTINE MLATM(IU,NL,NATM,NM1,NM2,IDM,IDMS,WMOL,RAMS,AIRM
     & ,ALT,PMATM,TMATM,DNSTY,AMOL,TRAC,ERR)
C SET MODEL PROFILES
C--- HISTORY
C 90. 2.24 MODIFIED BY T. NAKAJIMA
C 92. 3.30 IDMS*8 -> IDMS FOR SUN-SPARC READ-STATEMENT TROUBLE
C 94. 3.29 IDMS(I,J)=' ' -> 0
C 94. 6.20 add return
C    10.30 9 format(A8) for IBM
C 95. 9.15 REWIND IU
C--- INPUT
C IU        I         READ UNIT NUMBER
C--- OUTPUT
C NL        I         NUMBER OF LAYERS = 50
C NATM      I         NUMBER OF MODEL ATMOSPHERES = 6
C NM1       I         NUMBER OF MOLECULES OF FIRST KIND = 7
C NM2       I         NUMBER OF MOLECULES OF SECOND KIND = 21
C IDM     C(KNM)*8    MOLECULAR ID
C IDMS   I(KNM,10)    ISOTOPE ID (0 MEANS END)
C WMOL   R(KNM,10)    MOLECULAR WEIGHTS
C RAMS   R(KNM,10)    RELATIVE ABUNDANCE OF ISOTOPES (0 MEANS END)
C AIRM      R         MOLECULAR WEIGHT OF AIR
C ALT     R(KNL)      ALTITUDE (K)
C PMATM  R(KNL,KATM)  MODEL PRESSURE PROFILES (MB)
C                     1: TROPICAL,
C                     2: MID-LATITUDE SUMMER,  3: MID-LATITUDE WINTER
C                     4: HIGH-LAT SUMMER    ,  5: HIGH-LAT WINTER
C                     6: US STANDARD
C TMATM  R(KNL,KATM)  MODEL TEMPERATURE PROFILES
C DNSTY  R(KNL,KATM)  DENSITY (AIR MOLECULES / CM3) = P*NA/R/T
C AMOL   R(KNL,KNM1   MOLECULAR PROFILES (PPMV)
C            ,KATM)   1: H2O    2: CO2     3: O3      4: N2O     5: CO
C                     6: CH4    7: O2
C TRAC   R(KNL,KNM2)  TRACE GASE FROFILES (PPMV)
C                     8: NO     9: SO2    10: NO2    11: NH3    12: HNO3
C                    13: OH    14: HF     15: HCL    16: HBR    17: HI
C                    18: CLO   19: OCS    20: H2CO   21: HOCL   22: N2
C                    23: HCN   24: CH3CL  25: H2O2   26: C2H2   27: C2H6
C                    28: PH3
C
C ERR      C*64       ERROR INDICATER
C
C--- DATA FILE
C MLATMD
C--- AREA FOR THIS ROUTINE
C
      Include 'VISIRparameters.inc'
c
c      PARAMETER (KNL   =50)
c      PARAMETER (KNM1  =7)
c      PARAMETER (KNM2  =21)
c      PARAMETER (KATM  =6)
c      PARAMETER (KNM=KNM1+KNM2)
      CHARACTER ERR*(*),IDM(KNM)*8
      DIMENSION WMOL(KNM,10),RAMS(KNM,10),ALT(KNL),PMATM(KNL,KATM)
     & ,TMATM(KNL,KATM),DNSTY(KNL,KATM),AMOL(KNL,KNM1,KATM)
     & ,TRAC(KNL,KNM2),IDMS(KNM,10)
C--- WORK AREA
      CHARACTER CH*1
      ERR=' '
      REWIND IU
C READ NUMBERS
      READ(IU,1) CH
    1 FORMAT(A1)
      READ(IU,*) NM1,NM2,NATM,NL
      NM=NM1+NM2
C READ MOLECULAR INFORMATION
      READ(IU,1) CH
      READ(IU,*) AIRM
      READ(IU,1) CH
      DO 2 I=1,NM
      READ(IU,9) IDM(I)
    9 format(A8)
      READ(IU,*) NS
      DO 3 J=1,10
      IDMS(I,J)=0
    3 RAMS(I,J)=0
      READ(IU,*) (IDMS(I,J),J=1,NS)
      READ(IU,*) (WMOL(I,J),J=1,NS)
    2 READ(IU,*) (RAMS(I,J),J=1,NS)
C READ ALTITUDE
      READ(IU,1) CH
      READ(IU,*) (ALT(I),I=1,NL)
C READ PRESSURE
      DO 4 J=1,NATM
      READ(IU,1) CH
    4 READ(IU,*) (PMATM(I,J),I=1,NL)
C READ TEMPERATURE
      DO 5 J=1,NATM
      READ(IU,1) CH
    5 READ(IU,*) (TMATM(I,J),I=1,NL)
C READ MOLECULAR PROFILES
      DO 6 K=1,NM1
      DO 6 J=1,NATM
      READ(IU,1) CH
    6 READ(IU,*) (AMOL(I,K,J),I=1,NL)
      DO 7 J=1,NATM
      READ(IU,1) CH
    7 READ(IU,*) (DNSTY(I,J),I=1,NL)
C READ TRACE GASE PROFILES
      DO 8 K=1,NM2
      READ(IU,1) CH
    8 READ(IU,*) (TRAC(I,K),I=1,NL)
C
      return
      END
